"use strict";
this.name = "PlanetFall2_PlanetRotation";
this.author = "phkb";
this.copyright = "Creative Commons Attribution - Non-Commercial - Share Alike 3.0 license with clauses - see readme.txt.";
this.description = "Script that slows planet rotation as you approach it";

//-------------------------------------------------------------------------------------------------------------
this.startUpComplete = function() {
    this.$recordInitialValues();
    this.$nearestPlanet = worldScripts.PlanetFall2_Turbulence.$nearestPlanet;
    this.$altitude = worldScripts.PlanetFall2_Turbulence.$altitude;
    this._maxalt = worldScripts.PlanetFall2._config.atmosphereMax * 1000;
}

//-------------------------------------------------------------------------------------------------------------
this.shipExitedWitchspace = function() {
    this.$recordInitialValues();
    // in case there's a planet near the witchpoint
    this.shipLaunchedFromStation();
}

//-------------------------------------------------------------------------------------------------------------
this.$recordInitialValues = function() {
    var pl = system.planets;
    var i = pl.length;
    while (i--) {
        pl[i].stored_rotationalVelocity = pl[i].rotationalVelocity;
    }
}

//-------------------------------------------------------------------------------------------------------------
this.shipLaunchedFromStation = function() {
    this._nearest = this.$nearestPlanet();
    if (this._nearest && this.$altitude(player.ship, this._nearest) < (this._nearest.radius * 3)) this.shipEnteredPlanetaryVicinity(this._nearest);
}

//-------------------------------------------------------------------------------------------------------------
this.shipEnteredPlanetaryVicinity = function(entity) {
    if (worldScripts.PlanetFall2._config.planetRotation == false) return;
    if (entity.isSun) return;
    this._nearest = entity;
    this._timer = new Timer(this, this.$checkAlt.bind(this), 0.25, 0.25);
}

//-------------------------------------------------------------------------------------------------------------
this.shipExitedPlanetaryVicinity = this.shipDockedWithStation = this.shipDied = this.shipWillEnterWitchspace = function(entity) {
    if (this._timer && this._timer.isRunning) this._timer.stop();
}

//-------------------------------------------------------------------------------------------------------------
this.$checkAlt = function $checkAlt() {
    if (!this._nearest) return;
    if (!player.ship || !player.ship.isValid) return;
    var alt = this.$altitude(player.ship, this._nearest);
    var pl = this._nearest;
    if (alt >= this._maxalt) {
        pl.rotationalVelocity = pl.stored_rotationalVelocity;
    } else if (alt < 1000) {
        pl.rotationalVelocity = 0;
    } else {
        pl.rotationalVelocity = pl.stored_rotationalVelocity * (alt / this._maxalt);
    }
}
